# ndctl-activate-firmware(1)

[NAME<br>](#name)[SYNOPSIS](#synopsis)\
[EXAMPLES](#examples)\
[OPTIONS](#options)\
[COPYRIGHT](#copyright)\
[SEE ALSO](#see-also)

## NAME <a href="#name" id="name"></a>

ndctl-activate-firmware - activate staged firmware on memory devices

## SYNOPSIS <a href="#synopsis" id="synopsis"></a>

ndctl activate-firmware \[\<bus-id> \<bus-id2> .. \<bus-idN>] \[\<options>]

Some persistent memory devices run a firmware locally on the device / “DIMM” to perform tasks like media management, capacity provisioning, and health monitoring. The process of updating that firmware typically involves a reboot because it has implications for in-flight memory transactions. However, reboots can be costly for systems that can not tolerate extended downtime.

The kernel detects platforms that expose support for runtime-firmware-activation (FWA). The *ndctl update-firmware* stages new firmware binaries, but if the platform supports FWA it will additionally arm the devices for activation. Then *ndctl activate-firmware* may attempt to activate the firmware live. However, if the platform indicates that the memory controller will be taken off-line for the duration of the update “activate\_method == suspend” then the default policy for firmware activation is to inject a truncated hibernate cycle to freeze devices and applications before the hard quiesce is injected by the platform, and then resume the system.

**DANGER** the activate-firmware command includes a `–force` option to tell the driver bypass the hibernation cycle and perform the update “live”. I.e. it arranges for applications and devices to race the platform injected quiesce period. This option should only be used with the explicit knowledge that the platform quiesce time will not trigger completion timeout violations for any devices in the system.

## EXAMPLES <a href="#examples" id="examples"></a>

Check for any buses that support activation without triggering an activation:

```
# ndctl activate-firmware all --dry-run
ACPI.NFIT: ndbus1: has no devices that support firmware update.
nfit_test.1: ndbus3: has no devices that support firmware update.
e820: ndbus0: has no devices that support firmware update.
[
  {
    "provider":"nfit_test.0",
    "dev":"ndbus1",
    "scrub_state":"idle",
    "firmware":{
      "activate_method":"suspend",
      "activate_state":"idle"
    },
    "dimms":[
      {
...
```

Check that a specific bus supports activation without performing an activation:

```
# ndctl activate-firmware nfit_test.0 --dry-run --force
[
  {
    "provider":"nfit_test.0",
    "dev":"ndbus2",
    "scrub_state":"idle",
    "firmware":{
      "activate_method":"suspend",
      "activate_state":"idle"
    },
    "dimms":[
...
]
```

The result is equivalent to `ndctl list -BFDu` upon successful activation.

The *ndctl list* command can also enumerate the default activation method:

```
# ndctl list -b nfit_test.0 -BF
[
  {
    "provider":"nfit_test.0",
    "dev":"ndbus2",
    "scrub_state":"idle",
    "firmware":{
      "activate_method":"suspend",
      "activate_state":"idle"
    }
  }
]
```

## OPTIONS <a href="#options" id="options"></a>

`-n; --dry-run`\
&#x20;Perform all actions related to activation including honoring –idle and –force, but skip the final execution of the activation. The overrides are undone before the command completes. Any failed overrides will be reported as error messages.

`-I; --idle`\
&#x20;Implied by default, this option controls whether the platform will attempt to increase the completion timeout of all devices in the system and validate that the max completion timeout satisfies the time needed to perform the activation. This validation step can be overridden by specifying –no-idle.

`-f; --force`\
&#x20;The activation method defaults to the reported “bus.firmware.activate\_method” property. When the method is “live” then this –force option is ignored. When the method is “reset” no runtime activation is attempted. When the method is “suspend” this option indicates to the driver to bypass the hibernate cycle to activate firmware. in the bus When the reported “activate\_method” is “suspend” the kernel driver may support overriding the suspend requirement and instead issue the firmware-activation live. **CAUTION** this may lead to undefined system behavior if device completion timeouts are violated for in-flight memory operations.

`-v; --verbose`\
&#x20;Emit debug messages for the firmware activation procedure

## COPYRIGHT <a href="#copyright" id="copyright"></a>

Copyright (c) 2016 - 2020, Intel Corporation. License GPLv2: GNU GPL version 2 <http://gnu.org/licenses/gpl.html>. This is free software: you are free to change and redistribute it. There is NO WARRANTY, to the extent permitted by law.

## SEE ALSO <a href="#see-also" id="see-also"></a>

[ndctl-update-firmware](https://docs.pmem.io/ndctl-user-guide/ndctl-man-pages/ndctl-update-firmware) , [Intel Optane PMem DSM Interface](https://pmem.io/documents/IntelOptanePMem_DSM_Interface-V2.0.pdf)


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.pmem.io/ndctl-user-guide/ndctl-man-pages/ndctl-activate-firmware.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
